/*
* This program is an improved version of the program Letter.cpp which displays a form letter on screen. 
*  (This letter is about the balance of a customer, its due date and possible late penalty information.
*  Some parts of the letter are fixed, some parts are inputs, some parts are to be calculated. )
*/

#include <iostream>
#include <string>

using namespace std;

/*
 * First compile and show the errors.
 * Then, uncomment these function prototypes to show that it will compile now.
 * Mention that the first one does not have the parameter names and jst the types.
 * And the second prototype have the parameter names as well as the types, and both are OK.
 * I even put printPenalty below main to show that as long as there is a prototype on top, 
 * it is ok to put the function definition anywhere in your program.
*/

void printDate(int, int, int);
void printPenalty(int balance, double monthlyInterest,int month);

void printLetter(string Name, string Lname, int Day, int Month, int Year, int Amount, double Interest)
{
	int dueDay, dueMonth, dueYear;

	dueDay = Day;
	dueMonth = (Month % 12) + 1;
	dueYear = Year + (Month / 12);


	cout <<"                                                                 ";
	printDate(Day,Month,Year);
	cout << endl << endl;
	cout << "Dear " << Name << " " << Lname << " :" << endl << endl;
	cout << "Our records shows a balance of " << Amount << " as of ";
	printDate(Day,Month,Year);
	cout << ". In order to avoid any late penalty please pay your balance in full until ";
	printDate(dueDay,dueMonth,dueYear);
	cout <<". Otherwise we have to charge late";
	cout << " penalty (monthly " << Interest << " % ) as shown below." << endl << endl;

	printPenalty(Amount, Interest, 1);
	printPenalty(Amount, Interest, 2);
	printPenalty(Amount, Interest, 3);

	cout << endl << endl << "Best Regards," << endl << endl;
	cout << "CS201 Corp." << endl << endl;
}

void printDate(int Day, int Month, int Year)
{
	cout << Day << " / " << Month << " / " << Year;
}

int main()
{
	string name, lname;
	int day, month, year, amount;
	double interest;

	cout << "This program prints a letter about the balance of "
		 << "a customer, its due date and possible late penalty "
		 << "information. Some parts of the letter are fixed, "
		 << "some parts are inputs, some parts are to be calculated." << endl << endl;

	cout << "Enter the following information ---" << endl;
	cout << endl << "Name : ";
	cin >> name;
	cout << endl << "Last Name : ";
	cin >> lname;
	cout << endl << "Day Month Year : ";
	cin >> day >> month >> year;
	cout << endl << "Amount : ";
	cin >> amount;
	cout << endl << "Interest : ";
	cin >> interest;
	cout << endl << endl << endl << endl << endl << endl << endl;

	if ( (amount <= 0)||(day > 31 || day < 1) || (month > 12 || month < 1)|| 
		 (year <= 0) || ( month == 2 && day > 29) )
	{
		cout << "Invalid date!" << endl;;
	} 
	else 
	{
		printLetter(name, lname, day, month, year, amount, interest);
	}

	return 0;
}

void printPenalty(int balance, double monthlyInterest,int month)
{
	double lateAmount;
	lateAmount = balance + month * (balance * monthlyInterest / 100);

	cout << 30 * month << " days past due, you pay " << lateAmount << endl;
}